{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}


type
   rec = record
      num,e1,e2: longint;
   end;

var
   a1,a2,a3,b1,b2,b3,c1,c2,c3,a,b,c,num_a,num_b,num_c: longint;
   sim_a,sim_b,sim_c: array[1..1000] of rec;


procedure init;
begin
   assign(input,'input.txt');
   reset(input);
   assign(output,'output.txt');
   rewrite(output);
   readln(a1,b1,c1);
   readln(a2,b2,c2);
   readln(a3,b3,c3);
   close(input);
end;


procedure do_simple;
var
   tmp,i,pos,count: longint;
begin
   tmp:=a;
   i:=2;
   pos:=1;
   num_a:=0;
   while tmp<>1 do
   begin
      count:=0;
      while tmp mod i=0 do
      begin
         tmp:=tmp div i;
         inc(count);
      end;
      if count>0 then
      begin
         sim_a[pos].num:=i;
         sim_a[pos].e1:=count;
         inc(pos);
      end;
      inc(i);
   end;
   num_a:=pos-1;

   tmp:=b;
   i:=2;
   pos:=1;
   while tmp<>1 do
   begin
      count:=0;
      while tmp mod i=0 do
      begin
         tmp:=tmp div i;
         inc(count);
      end;
      if count>0 then
      begin
         sim_b[pos].num:=i;
         sim_b[pos].e1:=count;
         inc(pos);
      end;
      inc(i);
   end;
   num_b:=pos-1;

   tmp:=c;
   i:=2;
   pos:=1;
   while tmp<>1 do
   begin
      count:=0;
      while tmp mod i=0 do
      begin
         tmp:=tmp div i;
         inc(count);
      end;
      if count>0 then
      begin
         sim_c[pos].num:=i;
         sim_c[pos].e1:=count;
         inc(pos);
      end;
      inc(i);
   end;
   num_c:=pos-1;
end;

function min(el1,el2,el3: longint): longint;
var
   tmp: longint;
begin
   if el1<el2
      then tmp:=el1
      else tmp:=el2;
   if el3<tmp
      then tmp:=el3;
   min:=tmp;
end;


procedure find_res;
var
   tmp1,tmp2,i,j,k: longint;
begin
   for i:=1 to num_a do
   begin
      j:=1;
      while (sim_b[j].num<sim_a[i].num) and (j<=num_b) do inc(j);
      if sim_b[j].num=sim_a[i].num
         then tmp1:=sim_b[j].e1
         else tmp1:=0;
      k:=1;
      while (sim_c[k].num<sim_a[i].num) and (k<=num_c) do inc(k);
      if sim_c[k].num=sim_a[i].num
         then tmp2:=sim_c[k].e1
         else tmp2:=0;
      sim_a[i].e2:=sim_a[i].e1-min(sim_a[i].e1,tmp1,tmp2);
   end;

   for i:=1 to num_b do
   begin
      j:=1;
      while (sim_a[j].num<sim_b[i].num) and (j<=num_a) do inc(j);
      if sim_a[j].num=sim_b[i].num
         then tmp1:=sim_a[j].e1
         else tmp1:=0;
      k:=1;
      while (sim_c[k].num<sim_b[i].num) and (k<=num_c) do inc(k);
      if sim_c[k].num=sim_b[i].num
         then tmp2:=sim_c[k].e1
         else tmp2:=0;
      sim_b[i].e2:=sim_b[i].e1-min(sim_b[i].e1,tmp1,tmp2);
   end;

   for i:=1 to num_a do
   begin
      j:=1;
      while (sim_c[j].num<sim_a[i].num) and (j<=num_c) do inc(j);
      if sim_c[j].num=sim_a[i].num
         then tmp1:=sim_c[j].e1
         else tmp1:=0;
      k:=1;
      while (sim_b[k].num<sim_a[i].num) and (k<=num_b) do inc(k);
      if sim_b[k].num=sim_a[i].num
         then tmp2:=sim_b[k].e1
         else tmp2:=0;
      sim_c[i].e2:=sim_c[i].e1-min(sim_a[i].e1,tmp1,tmp2);
   end;
end;

procedure work;
var
   s1,s2,s3: longint;
begin
   s1:=(a2+b2+c2)*(a3+b3+c3);
   s2:=(a1+b1+c1)*(a3+b3+c3);
   s3:=(a1+b1+c1)*(a2+b2+c2);
   a:=a1*s1+a2*s2+a3*s3;
   b:=b1*s1+b2*s2+b3*s3;
   c:=c1*s1+c2*s2+c3*s3;
   do_simple;
   find_res;
end;


procedure done;
var
   i,j,tmp: longint;
begin
   tmp:=1;
   for i:=1 to num_a do
      if sim_a[i].e2<>0 then
         for j:=1 to sim_a[i].e2 do
            tmp:=tmp*sim_a[i].num;
   write(tmp,' ');
   tmp:=1;
   for i:=1 to num_b do
      if sim_b[i].e2<>0 then
         for j:=1 to sim_b[i].e2 do
            tmp:=tmp*sim_b[i].num;
   write(tmp,' ');
   tmp:=1;
   for i:=1 to num_a do
      if sim_c[i].e2<>0 then
         for j:=1 to sim_c[i].e2 do
            tmp:=tmp*sim_c[i].num;
   write(tmp,' ');
   close(output);
end;

begin
   init;
   work;
   done;
end.

