// (C) Vadim Kopichenko (dl-support@gsu.unibel.by)
// cross solution for task ... at Gomel Regional Contest 2002

#include <stdlib.h>
#include <iostream.h>
typedef unsigned long ulong;

ulong nod(ulong a, ulong b) {
  while (a>0 && b>0) {
    if (a>b) a=ldiv(a, b).rem;
    else b=ldiv(b, a).rem;
  }
  return a+b;
}
inline ulong min(ulong a, ulong b, ulong c) {
  ulong h=a<b ? a : b;
  return h<c ? h : c;
}

ulong a1, a2, a3, b1, b2, b3, c1, c2, c3;
int main() {
  cin >> a1 >> b1 >> c1 >> a2 >> b2 >> c2 >> a3 >> b3 >> c3;
  ulong s1=a1+b1+c1, s2=a2+b2+c2, s3=a3+b3+c3;
  ulong h=nod(s1, nod(s2, s3));
  s1/=h; s2/=h; s3/=h;
  ulong va=a1*s2*s3+a2*s1*s3+a3*s1*s2;
  ulong vb=b1*s2*s3+b2*s1*s3+b3*s1*s2;
  ulong vc=c1*s2*s3+c2*s1*s3+c3*s1*s2;
  ulong nd=min(nod(va, vb), nod(vb, vc), nod(vc, va));
  cout << va/nd << ' ' << vb/nd << ' ' << vc/nd << endl;
  return 0;
}
