uses crt;
const kards:array[0..15]of string[2]=('A'+'4','A'+'1','A'+'2','A'+'3',
                                      'K'+'4','K'+'1','K'+'2','K'+'3',
                                      'Q'+'4','Q'+'1','Q'+'2','Q'+'3',
                                      'J'+'4','J'+'1','J'+'2','J'+'3');
var km:array[1..4,1..4]of integer;
    ar:array[1..1200,1..4]of word;
    n:word;
    f1,f2:text;

function ravno(var d,k:integer):boolean;
var rez:boolean;
    a,b,c:array[1..4,1..4]of byte;
    i,j:integer;

    function rav:boolean;
    var i,j:integer;
    begin
    rav:=true;
    for i:=1 to 4 do
    for j:=1 to 4 do
    if b[i,j]<>c[i,j] then
    begin
    rav:=false;
    exit;
    end;
    end;

begin
for i:=1 to 4 do
begin
a[i,1]:=(ar[d,i] div 256) div 16;
a[i,2]:=(ar[d,i] div 256) mod 16;
a[i,3]:=(ar[d,i] mod 256) div 16;
a[i,4]:=(ar[d,i] mod 256) mod 16;

b[i,1]:=(ar[k,i] div 256) div 16;
b[i,2]:=(ar[k,i] div 256) mod 16;
b[i,3]:=(ar[k,i] mod 256) div 16;
b[i,4]:=(ar[k,i] mod 256) mod 16;
end;

{1}
c:=a;
if rav then begin ravno:=true;exit; end;
{2}
for i:= 1 to 4 do for j:= 1 to 4 do c[i,j]:=a[5-i,j];
if rav then begin ravno:=true;exit; end;
{3}
for i:= 1 to 4 do for j:= 1 to 4 do c[i,j]:=a[i,5-j];
if rav then begin ravno:=true;exit; end;
{4}
for i:= 1 to 4 do for j:= 1 to 4 do c[i,j]:=a[5-i,5-j];
if rav then begin ravno:=true;exit; end;
{5}
for i:= 1 to 4 do for j:= 1 to 4 do c[i,j]:=a[j,i];
if rav then begin ravno:=true;exit; end;
{6}
for i:= 1 to 4 do for j:= 1 to 4 do c[i,j]:=a[j,5-i];
if rav then begin ravno:=true;exit; end;
{7}
for i:= 1 to 4 do for j:= 1 to 4 do c[i,j]:=a[5-j,i];
if rav then begin ravno:=true;exit; end;
{8}
for i:= 1 to 4 do for j:= 1 to 4 do c[i,j]:=a[5-j,5-i];
if rav then begin ravno:=true;exit; end;(**)
ravno:=false;
end;

procedure prorva;
var c,k:integer;
begin
k:=1;
repeat
c:=k+1;
while c<=n do if ravno(k,c) then begin ar[c]:=ar[n];dec(n); end else inc(c);
inc(k);
until n<=k;
end;

procedure vyvod;
var i,j,k:integer;
begin
for i:=1 to n do
begin
writeln(f1,ar[i,1]:6,ar[i,2]:6,ar[i,3]:6,ar[i,4]:6);

for j:=1 to 4 do
begin
km[j,4]:=(ar[i,j] div 256) div 16;
km[j,3]:=(ar[i,j] div 256) mod 16;
km[j,2]:=(ar[i,j] mod 256) div 16;
km[j,1]:=(ar[i,j] mod 256) mod 16;
end;

for j:=1 to 4 do
begin
for k:=1 to 4 do write(f2,kards[km[j,k]],' ');
writeln(f2);
end;
writeln(f2,'   ');
end;
end;


procedure dump;
var i,j:integer;
    c:word;
begin
inc(n);
for i:=1 to 4 do ar[n,i]:=km[i,1]+km[i,2]*16+km[i,3]*256+km[i,4]*256*16;
end;


procedure start;
var m1,m2,m3,m4:integer;
    k1,k2,k3,k4:integer;
begin
for m1:=0 to 3 do
for m2:=0 to 3 do if (m1<>m2) then
for m3:=0 to 3 do if (m2<>m3)and(m1<>m3) then
for m4:=0 to 3 do if (m2<>m4)and(m3<>m4)and(m1<>m4) then
for k1:=0 to 3 do
for k2:=0 to 3 do if (k1<>k2) then
for k3:=0 to 3 do if (k2<>k3)and(k1<>k3) then
for k4:=0 to 3 do if (k2<>k4)and(k3<>k4)and(k1<>k4) then
begin
km[1,1]:=m1*4+k1;km[1,2]:=m4*4+k2;km[1,3]:=m3*4+k4;km[1,4]:=m2*4+k3;
km[2,1]:=m3*4+k3;km[2,2]:=m2*4+k4;km[2,3]:=m1*4+k2;km[2,4]:=m4*4+k1;
km[3,1]:=m2*4+k2;km[3,2]:=m3*4+k1;km[3,3]:=m4*4+k3;km[3,4]:=m1*4+k4;
km[4,1]:=m4*4+k4;km[4,2]:=m1*4+k3;km[4,3]:=m2*4+k1;km[4,4]:=m3*4+k2;
dump;
km[1,4]:=m1*4+k1;km[1,3]:=m4*4+k2;km[1,2]:=m3*4+k4;km[1,1]:=m2*4+k3;
km[2,4]:=m3*4+k3;km[2,3]:=m2*4+k4;km[2,2]:=m1*4+k2;km[2,1]:=m4*4+k1;
km[3,4]:=m2*4+k2;km[3,3]:=m3*4+k1;km[3,2]:=m4*4+k3;km[3,1]:=m1*4+k4;
km[4,4]:=m4*4+k4;km[4,3]:=m1*4+k3;km[4,2]:=m2*4+k1;km[4,1]:=m3*4+k2;
dump;
end;
end;

begin
n:=0;
assign(f1,'testdata');
rewrite(f1);
assign(f2,'output.txt');
rewrite(f2);
start;
prorva;
vyvod;
close(f1);
close(f2);
halt;
end.
