#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define	NOERR	0
#define	INPNAME "con"
#define 	OUTNAME "con"

extern int _floatconvert;
#pragma extref _floatconvert

struct	taskdata	{
	long	input(void);
   long	solve(void);
   unsigned char	ins[1000];
	void doop(void);
   }data;
struct	taskres	{
	long	output(void);
   double	ans;
   }res;
FILE	*fpin,*fpout;
int	main(void)
	{
   fpin=fopen(INPNAME,"rt");
   fpout=fopen(OUTNAME,"wt");
   data.input();
   data.solve();
   res.output();
   return	NOERR;
   }
long	taskdata::input(void)
	{
   fscanf(fpin,"%s",ins);
   return	NOERR;
   }
#define	spush(st,free,_0a) (st[free]=_0a,free++)
#define	spop(st,free) (st[--free])
double	spa[1000];
long	sop[1000];
long	pri[300];
long	npa,nop;

void	taskdata::doop(void)
	{
	double a,b;
   long	op;

   a=spop(spa,npa);
   b=spop(spa,npa);
   op=spop(sop,nop);
   switch(op)	{
   case	'-':
   	a=b-a;
   	break;
   case	'+':
   	a=b+a;
   	break;
   case	'/':
   	a=b/a;
   	break;
   case	'*':
   	a=b*a;
   	break;
   	}
   a=floor(a);
   spush(spa,npa,a);
   }
long	taskdata::solve(void)
	{
   long	i,end;
	double	cnum;
   
   pri['/']=2;
   pri['*']=2;
   pri['-']=1;
   pri['+']=1;
   pri['(']=0;
   pri[')']=3;

	npa=nop=0;
	end=strlen(ins);
   cnum=0;
   for(i=0;i<end;i++)	{
   	switch(ins[i])	{
      case	'+':
      case	'-':
      case	'*':
      case	'/':
			while(nop>0 && pri[sop[nop-1]]>pri[ins[i]])	{
				doop();
      		}
         spush(sop,nop,ins[i]);
         if(cnum!=0)	{
	         spush(spa,npa,cnum);
   	      cnum=0;
            }
      	break;
      case	'(':
      	spush(sop,nop,ins[i]);
      	break;
      case	')':
      	spush(spa,npa,cnum);
         cnum=0;
			while(sop[nop-1]!='(')	{
				doop();
      		}
         spop(sop,nop);
         break;
      case	' ':
      	if(cnum!=0)
      		spush(spa,npa,cnum);
      	break;
      default:
			cnum=cnum*10+ins[i]-'0';      	
   		}
   	}
   if(cnum!=0)
   	spush(spa,npa,cnum);
	while(nop>0)	{
   	doop();
      }   
   res.ans=spop(spa,npa);
   return	NOERR;
   }
long	taskres::output(void)
	{
   fprintf(fpout,"%.0lf",ans);
   scanf("%*c");
   return	NOERR;
   }
