{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M 65520,0,655360}

const
     NameIn  =  'input.txt' ;
     NameOut =  'output.txt' ;

var
   FileIn , FileOut  :  text ;
   i , j , N         :  longint ;
   LenCurFact        :  longint ;
   Fact              :  array [1..32000] of word ;

procedure DataIn;
begin
     Assign( FileIn , NameIn );
     ReSet( FileIn );
     Readln( FileIn , N );
     Close( FileIn );
end;

procedure DataOut;
begin
     Assign( FileOut , NameOut );
     ReWrite( FileOut );
     for i := LenCurFact downto 1 do
       Write( FileOut , Fact[i] );
     Close( FileOut );
end;

procedure SolveProblem;
begin
     FillChar( Fact , SizeOf(Fact) , 0 );
     LenCurFact := 1 ;
     Fact[LenCurFact] := 1 ;
     for i := 1 to N do
       begin
            for j := 1 to LenCurFact do
              Fact[j] := Fact[j] * i ;
            for j := 1 to LenCurFact + 10 do
              begin
                   Fact[j+1] := Fact[j+1] + Fact[j] div 10 ;
                   Fact[j] := Fact[j] mod 10 ;
              end;
            j := LenCurFact + 10 ;
            while Fact[j] = 0 do
              Dec( j );
            if Fact[j] > 0 then LenCurFact := j ;
       end;
end;

begin
     DataIn;
     SolveProblem;
     DataOut;
end.