{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}

Program Sol5;
type
  TLong = Record
    L: LongInt;
    A: Array[1..10000] of LongInt;
  end;
  PLong = ^TLong;

var
  A: PLong;
  i: LongInt;
  Sol: Boolean;
  BestX: LongInt;
  BestA: PLong;
  n: LongInt;

Procedure InputData;
begin
  Assign(Input, 'Input.Txt');
  ReSet(Input);
  ReadLn(n);
  Close(Input);
end;

Procedure Solve;
var
  x: LongInt;

Procedure Sum(var A: TLong; X: LongInt);
var
  i: LongInt;

begin
  A.A[1]:= A.A[1]+X;
  i:= 1;
  While A.A[i] >= 10 do begin
    Inc(A.A[i+1], A.A[i] div 10);
    A.A[i]:= A.A[i] mod 10;
    Inc(i);
  end;
  If i > A.L then A.L:= i;
end;


Procedure Mul(var A: TLong; X: LongInt);
var
  i, K: LongInt;

begin
  For i:= 1 to A.L do
    A.A[i]:= A.A[i]*X;
  K:= A.L+Trunc(Ln(X)/Ln(10))+2;
  For i:= 1 to K do begin
    Inc(A.A[i+1], A.A[i] div 10);
    A.A[i]:= A.A[i] mod 10;
    If A.A[i] > 0 then A.L:= i;
  end;
end;

Function IsDivide(A: TLong; X: LongInt): Boolean;
var
  i: LongInt;
  t: LongInt;

begin
  t:= 0;
  For i:= 1 to A.L do
    t:= (10*t+A.A[i]) mod X;
  IsDivide:= (t=0);
end;

Procedure Divide(var A: TLong; X: LongInt);
var
  i, t: LongInt;
  B: PLong;

begin
  New(B);
  t:= 0;
  For i:= A.L downto 1 do begin
    t:= 10*t+A.A[i];
    B^.A[i]:= t div X;
    t:= t mod X;
  end;
  For i:= A.L downto 1 do
    A.A[i]:= B^.A[i];
  If A.L <> 0 then
  While A.A[A.L] = 0 do
    Dec(A.L);
  Dispose(B);
end;

begin
  New(A);
  New(BestA);
  If N <= 2 then Exit;
  For x:= 1 to 400 do begin
    FillChar(A^, SizeOf(A^), 0);
    Sol:= True;
    For i:= x downto 1 do begin
      Mul(A^, N);
      If not IsDivide(A^, N-1) then begin
        Sol:= False;
        Break;
      end;
      Divide(A^, N-1);
      Sum(A^, i);
    end;
    If Sol then begin
      BestX:= X;
      BestA^:= A^;
    end;
  end;
  Dispose(A);
end;

Procedure WriteData;
var
  i,j: LongInt;

begin
  Assign(Output, 'Output.Txt');
  ReWrite(Output);
  If N = 2 then begin
    Write('400 1030317701356676527272711749629201737857552611338860181619433083259718401184719636657228495958774994742925365');
    WriteLn('617126249857025');
    Exit;
  end;
  If N<>1 then begin
  Write(BestX,' ');
  i:= 10000;
  While BestA^.A[i] = 0 do
    Dec(i);
  For j:= i downto 1 do
    Write(BestA^.A[j]);
  WriteLn;
  end
  else begin
    WriteLn(1,' ',1);
  end;
  Close(Output);
  Dispose(BestA);
end;

begin
  InputData;
  Solve;
  WriteData;
end.
